﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinLiveTileView

Public Class TileControl
     Public Const AisleGroupName As String = "Groups"
    Public Const ShelfGroupName As String = "Categories"
    Public Const DocumentsGroupName As String = "Documents"


    Public Sub New()

        InitializeComponent()


        UltraLiveTileView1.TileSizing = TileSizing.None
        UltraLiveTileView1.ApplicationBar.ShowDefaultButtons = False
        UltraLiveTileView1.ApplicationBar.Appearance.BackColor = Color.FromArgb(42, 115, 61)
        UltraLiveTileView1.ApplicationBar.Appearance.BackColor2 = Color.FromArgb(87, 158, 105)
        UltraLiveTileView1.TextRenderingMode = Infragistics.Win.TextRenderingMode.GDI
        
        'UltraLiveTileView1.ApplicationBar.Visible = True

    End Sub

    Public Sub Populate()
        AddGroup1()

        LoadApplicationBarButtons()

        'UltraLiveTileView1.TextRenderingMode = TextRenderingMode.Default

    End Sub

    Private Sub AddGroup1()
        Dim d1 = new TileData
        d1.Text = "Test 1 Group Name"

        Dim d2 = new TileData
        d2.Text = "Test 2 Group Name"

        Dim d3 = new TileData
        d3.Text = "Test 3 Group Name"

        Dim grouptext as String
        grouptext = "IPD"

        

        AddTile(d1.Text, 1, TileSize.Medium, AisleGroupName, WindowsApplication1.My.Resources.add, d1, grouptext)
        AddTile(d2.Text, 2, TileSize.Medium, AisleGroupName, WindowsApplication1.My.Resources.add, d2, grouptext)
        AddTile(d3.Text, 3, TileSize.Medium, AisleGroupName, WindowsApplication1.My.Resources.add, d3, grouptext)
    End Sub

    Private Sub LoadApplicationBarButtons()
        Dim b1 = New ApplicationBarButton()
        UltraLiveTileView1.ApplicationBar.ButtonsLeft.Add(b1)
        b1.Text = "Add"
    End Sub

    Private Sub AddGroup2(data As TileData)
        ClearGroup(DocumentsGroupName)
        ClearGroup(ShelfGroupName)

        Dim d1 = new TileData
        d1.Text = "IPD"

        Dim d2 = new TileData
        d2.Text = "What now?"

        AddTile(d1.Text,4,TileSize.Medium, ShelfGroupName, WindowsApplication1.My.Resources.add, d1, data.Text)
        AddTile(d2.Text,5,TileSize.Medium, ShelfGroupName, WindowsApplication1.My.Resources.add, d2, data.Text)

    End Sub
    Private Sub AddGroup3(data As TileData)
        ClearGroup(DocumentsGroupName)

        AddTile("test6",6,TileSize.Medium, DocumentsGroupName, WindowsApplication1.My.Resources.add, Nothing, data.Text)
        AddTile("test7",7,TileSize.Medium, DocumentsGroupName, WindowsApplication1.My.Resources.add, Nothing, data.Text)
    End Sub


    Private Sub UltraButton1_Click(sender As Object, e As EventArgs) 
        
        'UltraLiveTileView1.ApplicationBar.ButtonsLeft.Clear()
    End Sub

    Private Sub UltraLiveTileView1_ApplicationBarButtonClick(sender As Object, e As ApplicationBarButtonClickEventArgs) Handles UltraLiveTileView1.ApplicationBarButtonClick
        MessageBox.Show("Test")
        ultraLiveTileView1.PerformAction(Infragistics.Win.UltraWinLiveTileView.UltraLiveTileViewAction.HideApplicationBar)
    End Sub

    Private Sub UltraLiveTileView1_TileClick(sender As Object, e As TileClickEventArgs) Handles UltraLiveTileView1.TileClick
        Select Case e.Tile.Group.Key
            Case AisleGroupName
                AddGroup2(DirectCast(e.Tile.Tag,TileData))
            Case ShelfGroupName
                AddGroup3(DirectCast(e.Tile.Tag,TileData))
        End Select
    End Sub
      Private Sub ClearGroup(groupName As String)
        If UltraLiveTileView1.Groups.ContainsKey(groupName)
            Dim group = UltraLiveTileView1.Groups(groupName)

            UltraLiveTileView1.Groups.Remove(groupName)
            group.Dispose()
        End If
    End Sub
      Private Sub AddTile(tileName As String, tileId As Integer, sizeOfTile As TileSize,
                        groupName As String, imageFile As String, linkedClass As Object, groupText As String)

        Dim imageBitmap As Image

        If Not String.IsNullOrWhiteSpace(imageFile) Then

            Using bmp As New Bitmap(imageFile)
                imageBitmap = New Bitmap(bmp)
            End Using
        End If

        AddTile(tileName, tileId, sizeOfTile, groupName, imageBitmap, linkedClass, groupText)

    End Sub
     Private Sub AddTile(tileName As String, tileId As Integer, sizeOfTile As TileSize,
                        groupName As String, imageBitmap As Image, linkedClass As Object, groupText As String)
        Dim group As TileGroup

        If UltraLiveTileView1.Groups.ContainsKey(groupName) Then
            group = UltraLiveTileView1.Groups.Item(groupName)
        Else
            group = UltraLiveTileView1.Groups.Add(groupName)
            'If groupName = AisleGroupName OrElse String.IsNullOrWhiteSpace(groupText) Then
            '    group.Text = " "
            'Else
                group.Text = groupText
                group.TextAreaAppearance.Normal.FontData.Name = "Arial"
                group.TextAreaAppearance.Normal.ForeColor = Color.FromArgb(42, 115, 61)
            'End If


            group.TextAreaAppearance.Editing.BackColor = Color.Transparent
            group.TextAreaAppearance.Editing.BackColor2 = Color.Transparent
            'group.Text = groupName
        End If

        If group.Tiles.Count > 1 Then Return

        Dim tile As TileBase

        tile = CreateMediumTile(tileName, imageBitmap)

        tile.Key = tileId.ToString()
        tile.Tag = linkedClass

        ConfigureTileColourBasedOnGroup(groupName, tile)
        group.Tiles.Add(tile)

    End Sub
Private Function CreateMediumTile(tileText As String, imageBitmap As Image) As TileBase
        Dim tile As New LiveTile()

        Dim frame As New LiveTileFrameMedium()
        Dim tileCustomContent As New LiveTileMediumCustomContent()


        Dim headerText As New LiveTileContentTextElement()
        headerText.Text = tileText
        headerText.TextSize = TileTemplateTextSize.Small
        headerText.Location = New Drawing.Point(10, 100)
        tileCustomContent.Elements.Add(headerText)
        frame.Content = tileCustomContent
        tile.DefaultView.MediumFrames.Add(frame)

        If imageBitmap IsNot Nothing Then
            Dim img As New LiveTileContentImageElement

            img.Image.AllResolutions.Image = New Bitmap(imageBitmap)
            img.Image.AllResolutions.Scaling = ImageScaling.ScaleToFit
            img.Location = New Point(20, 10)
            img.Size = New Size(80, 80)
            tileCustomContent.Elements.Add(img)

        End If

        tile.Sizing = TileSizing.Medium
        tile.CurrentSize = TileSize.Medium
        Return tile
    End Function
 Private Sub ConfigureTileColourBasedOnGroup(groupName As String, tile As TileBase)

        Dim backColour1 As Color
        Dim backColour2 As Color

        Select Case groupName
            Case AisleGroupName
                backColour1 = Color.FromArgb(0, 69, 15)
                backColour2 = Color.FromArgb(42, 115, 61)
            Case ShelfGroupName
                backColour1 = Color.FromArgb(42, 115, 61)
                backColour2 = Color.FromArgb(87, 158, 105)

            Case DocumentsGroupName
                backColour1 = Color.FromArgb(87, 158, 105)
                backColour2 = Color.FromArgb(146, 212, 161)

        End Select

        tile.Appearance.Normal.BackColor = backColour1
        tile.Appearance.Normal.BackColor2 = backColour2
        tile.Appearance.Normal.BorderColor = backColour2
        tile.Appearance.Normal.BorderColor2 = backColour1

    End Sub

    Private Sub UltraLiveTileView1_GroupEnteringEditMode(sender As Object, e As GroupEnteringEditModeEventArgs) Handles UltraLiveTileView1.GroupEnteringEditMode
         e.Cancel = True
    End Sub

    Private Class TileData
        Public Property Text As String
    End Class
End Class
